/*******************************************************************************
 *	@file			DL.h
 *	@brief			DirectX Library
 *
 *	@date			08-Apr-2009(Wed)
 ******************************************************************************/

#ifndef	__DL_INCLUDE__
#define	__DL_INCLUDE__

// ܂Ȃ
#define STRICT																	//!< ^`FbNɍs
#define	WIN32_LEAN_AND_MEAN														//!< wb_[炠܂gȂ֐Ȃ

// vvZbT---------------------------------------------------------------
//#pragma warning( disable : 4995 )
// Windows Library
#pragma comment ( lib, "winmm.lib" )
// DirectX Library
#pragma comment ( lib, "d3d9.lib" )
#pragma comment ( lib, "d3dx9.lib" )
#pragma comment ( lib, "dsound.lib" )
#pragma comment ( lib, "dinput8.lib" )
#pragma comment ( lib, "dxguid.lib" )
#pragma comment ( lib, "dxerr9.lib" )
#pragma comment ( lib, "dxguid.lib" )

// Windows
#include <windows.h>
#include <tchar.h>
#include <assert.h>
#include <mmsystem.h>															//!< timeGetTime()
#include <stdio.h>

#define DIRECTINPUT_VERSION	0x0800												//!< ꉞŉĂ
// DirectX9
#include <d3dx9.h>																//!< Direct3D & Direct3DX
#include <dsound.h>																//!< DirectSound
#include <dinput.h>																//!< DirectInput
#include <dxerr9.h>																//!< DirectX̃G[

// _DXLibv2

#ifdef __cplusplus
extern "C" {
#endif

/*******************************************************************************
 *	@namespace	DL
 ******************************************************************************/
namespace	DL
{

// 萔`---------------------------------------------------------------------
#define EXIT				1
#define TRUE				1
#define FALSE				0

#define _RELEASE( x )		if( x != NULL ){ x->Release(); x = NULL; }
#define _MEMCHECK( m )		if( m != NULL ){ ::free( m ); m = NULL; }

#ifdef	_DEBUG
	#define _ASSERT( n )	assert( n );
#else	// _DEBUG
	#define _ASSERT( n )	{}
#endif	// _DEBUG

// 񋓌^`-------------------------------------------------------------------
/*******************************************************************************
 *	@enum		enumObject		DL.h			"DL.h"
 *	@brief		IuWFNg
 ******************************************************************************/
enum enumObject
{
	enumObject_Null			= 0,												//!< Ȃ
	// DirectX Graphics
	enumObject_GraphStart,
	enumObject_Rect			= enumObject_GraphStart,							//!< `(RECTgp)
	enumObject_Plane,															//!< 
	enumObject_Text,															//!< eLXg
	enumObject_GraphEnd,
	// DirectX Sound
	enumObject_SoundStart,
	enumObject_BGM			= enumObject_SoundStart,							//!< BGM
	enumObject_SE,																//!< SE
	enumObject_SoundEnd,
	// 
	enumObject_Max,
};

// \̒`-------------------------------------------------------------------

// NX-----------------------------------------------------------------------

// OO[oϐ---------------------------------------------------------
typedef void (*CallBack)( BYTE* byKey, DIMOUSESTATE* diMouse );

// O֐vg^Cv錾---------------------------------------------------
extern void* SetupGraph( const int& nWidth,
						 const int& nHeight,
						 const BOOL& bMode );
extern void* SetupSound( const BOOL& b3DSound );
extern void* SetupInput( void );
extern void* SetupDebug( void );

extern BOOL Init( const HWND& hWnd,
				  const float& fRate );
extern void Exec( CallBack pCall );
extern void End( void );

}	// namespace	DL

#ifdef __cplusplus
}
#endif

#endif	// __DL_INCLUDE__
