/*******************************************************************************
 *	@file			DLDebug.cpp
 *	@brief			DirectX Library
 *
 *	@date			29-May-2010(Sat)
 ******************************************************************************/

// vvZbT---------------------------------------------------------------
#include "DLDebug.h"

/*******************************************************************************
 *	@namespace	DL
 ******************************************************************************/
namespace	DL
{

// O[oϐ---------------------------------------------------------

// ֐vg^Cv錾---------------------------------------------------

// -----------------------------------------------------------------------------

/*******************************************************************************
 *	@fn				CDLDebug::CDLDebug( void )
 *	@retval			none						Ȃ
 *	@brief			RXgN^
 ******************************************************************************/
CDLDebug::CDLDebug( void )
	: m_nMeterNum( 0 )
	, m_bMeterFlag( FALSE )
	, m_nLogCnt( 0 )
{
#ifdef _DEBUG
	ClearMeasure();
	ClearLog();
#endif	// _DEBUG
}

/*******************************************************************************
 *	@fn				CDLGraph::~CDLGraph( void )
 *	@retval			none						Ȃ
 *	@brief			fXgN^
 ******************************************************************************/
CDLDebug::~CDLDebug( void )
{
#ifdef _DEBUG
#endif	// _DEBUG
}

/*******************************************************************************
 *	@fn				int CDLDebug::Init( void )
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			
 ******************************************************************************/
int CDLDebug::Init( void )
{
#ifdef _DEBUG
	m_bMeterFlag = ::QueryPerformanceFrequency( &m_lnBase );

#endif	// _DEBUG
	return TRUE;
}

/*******************************************************************************
 *	@fn				int CDLDebug::End( void )
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			I
 ******************************************************************************/
int CDLDebug::End( void )
{
#ifdef _DEBUG
#endif	// _DEBUG
	return TRUE;
}

/*******************************************************************************
 *	@fn				void CDLDebug::ClearMeasure( void )
 *	@retval			none						Ȃ
 *	@brief			vlNA
 ******************************************************************************/
void CDLDebug::ClearMeasure( void )
{
#ifdef _DEBUG
	// v
	for( int i = 0; i < METER_MAX; i++ )
		for( int j = 0; j < enumMeter_Max; j++ )
			m_lnMeter[ i ][ j ].QuadPart = 0;
	m_nMeterNum = 0;
#endif	// _DEBUG
}

/*******************************************************************************
 *	@fn				void CDLDebug::SetMeasure( void )
 *	@retval			none						Ȃ
 *	@brief			vlݒ
 ******************************************************************************/
void CDLDebug::SetMeasure( void )
{
#ifdef _DEBUG
	_ASSERT( m_nMeterNum < METER_MAX && "Measurement()" );
	// vJn
	if( m_lnMeter[ m_nMeterNum ][ enumMeter_Start ].QuadPart == 0 )
	{
		::QueryPerformanceCounter( &m_lnMeter[ m_nMeterNum ][ enumMeter_Start ] );
	}else
	// vI
	{
		::QueryPerformanceCounter( &m_lnMeter[ m_nMeterNum ][ enumMeter_End ] );
		m_nMeterNum++;
	}
#endif	// _DEBUG
}

/*******************************************************************************
 *	@fn				const float CDLDebug::GetMeasure( const int& nNum )
 *	@param[in]		nNum						擾ԍ
 *	@retval			float						fTime
 *	@brief			vl擾
 ******************************************************************************/
const float CDLDebug::GetMeasure( const int& nNum )
{
	float fTime = 0.0f;
#ifdef _DEBUG
	_ASSERT( nNum < METER_MAX && "GetMeasurement()" );

	fTime = static_cast<float>( ( ( m_lnMeter[ nNum ][ enumMeter_End ].QuadPart - m_lnMeter[ nNum ][ enumMeter_Start ].QuadPart ) * 1000 ) / m_lnBase.QuadPart );
	if( fTime < 0.0f ) fTime = 0.0f;
#endif	// _DEBUG
	return fTime;
}

/*******************************************************************************
 *	@fn				void CDLDebug::ClearLog( void )
 *	@retval			none						Ȃ
 *	@brief			ONA
 ******************************************************************************/
void CDLDebug::ClearLog( void )
{
#ifdef _DEBUG
	for( int i = 0; i < LOG_MAX; i++ )
		::strcpy_s( m_cLog[ i ], TEXT_MAX, "" );

	m_nLogCnt = 0;
#endif	// _DEBUG
}

/*******************************************************************************
 *	@fn				void CDLDebug::SetLog( const char* cLog )
 *	@retval			none						Ȃ
 *	@brief			Oݒ
 ******************************************************************************/
void CDLDebug::SetLog( const char* cLog )
{
#ifdef _DEBUG
	int nCnt = m_nLogCnt % LOG_MAX;
	::strcpy_s( m_cLog[ nCnt ], TEXT_MAX, cLog );
	m_nLogCnt++;
#endif	// _DEBUG
}

/*******************************************************************************
 *	@fn				const char* CDLDebug::GetLog( const int& nNum )
 *	@param[in]		nNum						擾ԍ
 *	@retval			char*						ObZ[W
 *	@brief			O擾
 ******************************************************************************/
const char* CDLDebug::GetLog( const int& nNum )
{
	char *cBuf = NULL;
#ifdef _DEBUG
	int nCnt = nNum % LOG_MAX;
	cBuf = m_cLog[ nCnt ];
#endif	// _DEBUG
	return cBuf;
}

}	// namespace	DL
