/*******************************************************************************
 *	@file			DLDebug.h
 *	@brief			DirectX Library
 *
 *	@date			29-May-2010(Sat)
 ******************************************************************************/

#ifndef	__DLDEBUG_INCLUDE__
#define	__DLDEBUG_INCLUDE__

// vvZbT---------------------------------------------------------------
#include "DL.h"
#include "DLGraph.h"

#ifdef __cplusplus
extern "C" {
#endif

/*******************************************************************************
 *	@namespace	DL
 ******************************************************************************/
namespace	DL
{

// 萔`---------------------------------------------------------------------
#pragma once

// 񋓌^`-------------------------------------------------------------------
/*******************************************************************************
 *	@enum		enumDraw		DLDebug.h		"DLDebug.h"
 *	@brief		v
 ******************************************************************************/
enum enumMeter
{
	enumMeter_Start			= 0,												//!< Jn
	enumMeter_End,																//!< I
	enumMeter_Max,
};

// \̒`-------------------------------------------------------------------

// NX-----------------------------------------------------------------------
/*******************************************************************************
 *	@class		CDLDebug		DLDebug.h			"DLDebug.h"
 *	@brief		CDLDebugNX
 ******************************************************************************/
class CDLDebug
{
// 萔`---------------------------------------------------------------------
private:
protected:
public:
	static const int METER_MAX		= 4;										//!< v
	static const int LOG_MAX		= 64;										//!< O
	static const int TEXT_MAX		= 256;										//!< O

// o֐-------------------------------------------------------------------
private:
protected:
public:
	CDLDebug( void );
	~CDLDebug( void );

	int Init( void );															//!< 
	int End( void );															//!< I

	// vl
	void ClearMeasure( void );													//!< vlNA
	void SetMeasure( void );													//!< vlݒ
	const float GetMeasure( const int& nNum );									//!< vl擾

	// O
	void ClearLog( void );														//!< ONA
	void SetLog( const char* cLog );											//!< Oݒ
	const char* GetLog( const int& nNum );										//!< O擾
	const int& GetLogCnt( void ) const { return m_nLogCnt; }					//!< OJEg擾

// oϐ-------------------------------------------------------------------
private:
	LARGE_INTEGER			m_lnBase;											//!< v̓y
	LARGE_INTEGER			m_lnMeter[ METER_MAX ][ enumMeter_Max ];			//!< v
	int						m_nMeterNum;										//!< v
	BOOL					m_bMeterFlag;										//!< vJE^[

	char					m_cLog[ LOG_MAX ][ TEXT_MAX ];						//!< O
	int						m_nLogCnt;											//!< OJEg

protected:
public:

};

// OO[oϐ---------------------------------------------------------

// O֐vg^Cv錾---------------------------------------------------

}	// namespace	DL

#ifdef __cplusplus
}
#endif

#endif	// __DLDEBUG_INCLUDE__
